local Recount2 = Recount2
local tinsert = table.insert

local function CreateDropdown(self)
	Recount2.Widgets:DropdownClear()
	for _, filter in ipairs(self.filters) do
		Recount2.Widgets:DropdownAddButton(filter.name, self.SetFilter, self, filter)
	end

	Recount2.Widgets:DropdownAddDivider()
	Recount2.Widgets:DropdownAddButton("Config", Recount2.Configs.ConfigMainList, Recount2, self.name)

	Recount2.Widgets:DropdownAddDivider()
	Recount2.Widgets:DropdownAddButton("Print Local", self.listFrame.Report, self.listFrame, self.filterName, 10)
	Recount2.Widgets:DropdownAddButton("Report to Say", self.listFrame.Report, self.listFrame, self.filterName, 10, "SAY")
	if GetNumPartyMembers()>0 then
		Recount2.Widgets:DropdownAddButton("Report to Party", self.listFrame.Report, self.listFrame, self.filterName, 10, "PARTY")
	end
	if GetNumRaidMembers()>0 then
		Recount2.Widgets:DropdownAddButton("Report to Raid", self.listFrame.Report, self.listFrame, self.filterName, 10, "RAID")
	end
	if IsInGuild() then
		Recount2.Widgets:DropdownAddButton("Report to Guild", self.listFrame.Report, self.listFrame, self.filterName, 10, "GUILD")
	end

	Recount2.Widgets:DropdownOpen()
end

local function SetFilter(self, filter)
	local dataSource
	self.title:SetText(self.name.." - "..filter.name)
	self.filterName = filter.name
	self.filter = filter

	if filter.dataSource=="Overall" then
		dataSource = Recount2.Data.Overall
	end

	self.listFrame:SetView(filter.barValue, filter.leftText, filter.rightText, dataSource, filter.srcCombatant, filter.dstCombatant, filter.infoFilter, filter.powerFilter, filter.schoolFilter, filter.typeFilter, filter.groupOn)
end

local function ResetCurFilter(self)
	self:SetFilter(self.filter)
end

local function RowClicked(name, data, self, detailWindowName)
	Recount2:UpdateDetailWindow(detailWindowName, self.filterName.." Details For "..name, data)
end

function Recount2:UpdateMainListWindow(name, filter, filters)
	local window = Recount2.mainListWindows[name]

	if window == nil then
		window=Recount2.Widgets:CreateWindow("Recount2_MainListWindow_"..name, 400, 200)
		window:SetPoint("TOP", UIParent, "TOP")
		window:SetMinResize(100,100)

		window.listFrame = Recount2:CreateListFrame("Recount2_MainListWindow_"..name, window, 100, 100, 14, 1, RowClicked, {window, "FromMain"..name})
		window.listFrame:ClearAllPoints()
		window.listFrame:SetAllPoints(window.innerFrame)

		window.SetFilter = SetFilter
		window.ResetCurFilter = ResetCurFilter

		Recount2.mainListWindows[name] = window

		window.name = name

		window.CreateDropdown = CreateDropdown
		window:SetRightClickTitleFunc(window.CreateDropdown, window)
		window.filters = {}
	end
	
	
	for k in ipairs(window.filters) do
		window.filters[k] = nil
	end

	for k, v in ipairs(filters) do
		tinsert(window.filters, v)
	end
	
	window:SetFilter(filter)
	window:Show()
end

